#property copyright "*"
#property link      "*"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 DodgerBlue

#property indicator_width1 5
#property indicator_width2 5

//---- input parameters
extern double k1=1.0;
extern double k2=3.0;
extern double k3=6.0;
extern double k4=24.0;
extern int  FromAr=30;
extern int Pr=0;

//---- buffers

double A1[];
double A2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,241);
   SetIndexBuffer(0,A1);
   
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,242);
   SetIndexBuffer(1,A2);   
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){
  double m;
  double c,p;
   int limit=Bars-IndicatorCounted();
      for(int i=limit-1;i>=0;i--){
         c=IndVal2(k4,i)+IndVal2(k3,i)+IndVal2(k2,i)+IndVal2(k1,i);         
         p=IndVal2(k4,i+1)+IndVal2(k3,i+1)+IndVal2(k2,i+1)+IndVal2(k1,i+1);
         
         A1[i]=EMPTY_VALUE;
         A2[i]=EMPTY_VALUE; 
         
         if(c>0 && p<=0)A1[i]=Low[i]-Point*FromAr;
         if(c<0 && p>=0)A2[i]=High[i]+Point*FromAr;         
                 
         
      }
   return(0);
  }
//+------------------------------------------------------------------+

double IndVal2(double Koef,int Ind){
   double c=0;
   double m=0;
      m=iMACD(NULL,0,Koef*3,Koef*30,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;         
      m=iMACD(NULL,0,Koef*5,Koef*35,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;                    
      m=iMACD(NULL,0,Koef*8,Koef*40,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;          
      m=iMACD(NULL,0,Koef*10,Koef*45,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;   
      m=iMACD(NULL,0,Koef*12,Koef*50,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;
      m=iMACD(NULL,0,Koef*15,Koef*60,9,Pr,MODE_MAIN,Ind);
         if(m>0)c++;
         if(m<0)c--;
   if(c>0)return(1);
   if(c<0)return(-1);   
   if(c==0)return(0);   
}